/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/



package lsagpi;

import java.util.StringTokenizer;
import java.util.Vector;

/**
 * Clase para definir acciones.
 * @author Miguel Angel Pescador Santirso
 */
public class Accion {
final int DI=0;
final int MOVER=1;
final int GIRAR=2;
final int ESPERAR=3;
final int SALIR=4;
final int SELECCIONARPOSICION=5;
final int SELECCIONARTINTA=6;
final int SELECCIONARETIQUETA=7;
final int SELECCIONARJUGADOR=8;
final int DORMIR=9;
final int CAMINAR=10;
final int SALTAR=11;
final int SI=12;
final int ENTONCES=13;
final int OTRO=14;
final int MIENTRAS=15;
final int PARA=16;
final int COLOCAR=17;
final int LOCALIZAR=18;
//final int SELECCIONARJUGADOR=19;
//final int DORMIR=20;
//final int CAMINAR=21;


Vector instruccion=new Vector();
Vector<Vector> acciones=new Vector<Vector>();
boolean nopasar=false;
/**
 * Constructor de Accion
 * @param definicion Definicion de la Accion.
 */
    public Accion(String definicion){
        StringTokenizer st = new StringTokenizer(definicion,"\n",true);
        //nombre=st.nextToken();
        
        while (st.hasMoreTokens())
		{
            String cadena=new String("");
            if(nopasar==false){
                cadena=st.nextToken();
            }else{
                nopasar=false;
            }
            if(cadena.indexOf("INSTRUCCION")!=-1){
                StringTokenizer ins_tok=new StringTokenizer(cadena," ");
                if(ins_tok.nextToken().trim().equals("INSTRUCCION")){
                    while(ins_tok.hasMoreTokens()){
                        String ins=ins_tok.nextToken();
                        if(ins.indexOf("{")==-1)
                            instruccion.add(ins.trim());
                    }
                }
            }
            if(cadena.indexOf("{")!=-1)
                st.nextToken();
            if(cadena.indexOf("DI")!=-1){
                Vector accion=new Vector();
                System.out.println("Un DI");
                StringTokenizer ins_tok=new StringTokenizer(cadena," ");
                if(ins_tok.nextToken().trim().equals("DI")){
                    accion.add(DI);
                    accion.add(ins_tok.nextToken().trim());
                    String texto=new String("");
                    while(ins_tok.hasMoreTokens()){
                          texto+=ins_tok.nextToken()+" ";
                        }
                    System.out.println(texto.substring(1,texto.length()-3));
                    accion.add(texto.substring(1,texto.length()-3));
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("MOVER")!=-1){
                Vector accion=new Vector();
                System.out.println("Un MOVER");
                accion.add(MOVER);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("MOVER")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SELECCIONARTINTA")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SELECCIONARTINTA");
                accion.add(SELECCIONARTINTA);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SELECCIONARTINTA")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SELECCIONARPOSICION")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SELECCIONARPOSICION");
                accion.add(SELECCIONARPOSICION);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SELECCIONARPOSICION")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());

                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SELECCIONARETIQUETA")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SELECCIONARETIQUETA");
                accion.add(SELECCIONARETIQUETA);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SELECCIONARETIQUETA")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SELECCIONARJUGADOR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SELECCIONARJUGADOR");
                accion.add(SELECCIONARJUGADOR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SELECCIONARETIQUETA")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("ESPERAR")!=-1){
                Vector accion=new Vector();
                 System.out.println("Un ESPERAR");
                accion.add(ESPERAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("ESPERAR")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("DORMIR")!=-1){
                Vector accion=new Vector();
                 System.out.println("Un DORMIR");
                accion.add(DORMIR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("DORMIR")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("GIRAR")!=-1){
                Vector accion=new Vector();
                //Por Implementar
                accion.add(GIRAR);
            }
            if(cadena.indexOf("SALTAR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un SALTAR");
                accion.add(SALTAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("SALTAR")){
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("COLOCAR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un COLOCAR");
                accion.add(COLOCAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("COLOCAR")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("LOCALIZAR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un LOCALIZAR");
                accion.add(LOCALIZAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("LOCALIZAR")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("CAMINAR")!=-1){
                Vector accion=new Vector();
                System.out.println("Un CAMINAR");
                accion.add(CAMINAR);
                StringTokenizer ins_tok=new StringTokenizer(cadena);
                if(ins_tok.nextToken().trim().equals("CAMINAR")){
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                    accion.add(ins_tok.nextToken());
                }
                acciones.add(accion);
            }
            if(cadena.indexOf("SALIR")!=-1){
                Vector accion=new Vector();
                accion.add(SALIR);
                acciones.add(accion);
            }
            //Inicio de bloques lógicos
            if(cadena.indexOf("SI")!=-1){
                System.out.println("Bloque SI");
                
                String num=new String("");
                Vector expresion=new Vector();
                if(cadena.indexOf("SI")!=-1 && cadena.indexOf("{")!=-1){}
                else{cadena=st.nextToken();}
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("{") && num_tok.hasMoreTokens()){
                        System.out.println("entra");
                        expresion.add(SI);
                        while(num_tok.hasMoreTokens()){
                            String num2=num_tok.nextToken().trim();
                            System.out.println(num2);
                            expresion.add(num2);
                        }
                    }else{
                        cadena=st.nextToken();
                        while(cadena.indexOf("{")!=-1 || cadena.trim().equals("\n"))
                            cadena=st.nextToken();
                        System.out.println("entra2");
                        cadena=st.nextToken();
                        System.out.println(cadena);
                        StringTokenizer num2_tok=new StringTokenizer(cadena);
                        expresion.add(SI);
                        while(num2_tok.hasMoreTokens()){
                            String num2=num2_tok.nextToken().trim();
                            System.out.println(num2);
                            expresion.add(num2);
                        }
                    }

                }
                System.out.println(cadena);
                cadena=st.nextToken();
                System.out.println(cadena);
                while(cadena.indexOf("}")!=-1 || cadena.trim().isEmpty())
                    cadena=st.nextToken();
                if (cadena.indexOf("ENTONCES")!=-1){
                    System.out.println("Bloque ENTONCES");
                    cadena=st.nextToken();
                    String cadenaEntonces=new String("");
                    while(cadena.indexOf("{")==-1)
                        cadena=st.nextToken();
                    int contador=0;
                    while(contador!=-1){
                        cadena=st.nextToken();
                        if(cadena.indexOf("{")!=-1){
                            contador++;
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("{")!=-1 && cadena.indexOf("}")!=-1){
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("}")!=-1){
                            contador--;
                            cadenaEntonces+=cadena;
                        }else{
                            cadenaEntonces+=cadena;
                        }
                    }
                    System.out.println(cadenaEntonces);
                    Accion a=new Accion(cadenaEntonces);
                    expresion.add(a.acciones);

                }
                cadena=st.nextToken();
                while(cadena.indexOf("}")!=-1 || cadena.trim().isEmpty())
                    cadena=st.nextToken();
                if (cadena.indexOf("OTRO")!=-1){
                     System.out.println("Bloque OTRO");
                    cadena=st.nextToken();
                    String cadenaEntonces=new String("");
                    if(cadena.indexOf("{")!=-1)
                        cadena=st.nextToken();
                    int contador=0;
                    while(contador!=-1){
                        cadena=st.nextToken();
                        if(cadena.indexOf("{")!=-1){
                            contador++;
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("{")!=-1 && cadena.indexOf("}")!=-1){
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("}")!=-1){
                            contador--;
                            cadenaEntonces+=cadena;
                        }else{
                            cadenaEntonces+=cadena;
                        }
                    }
                    System.out.println(cadenaEntonces);
                    Accion a=new Accion(cadenaEntonces);
                    expresion.add(a.acciones);

                }else{nopasar=true;}
                acciones.add(expresion);
            }
            //Bloque ENTONCES
            if (cadena.indexOf("ENTONCES")!=-1){
                    System.out.println("Bloque ENTONCES");
                    cadena=st.nextToken();
                    String cadenaEntonces=new String("");
                    while(cadena.indexOf("{")==-1)
                        cadena=st.nextToken();
                    int contador=0;
                    while(contador!=-1){
                        cadena=st.nextToken();
                        if(cadena.indexOf("{")!=-1){
                            contador++;
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("{")!=-1 && cadena.indexOf("}")!=-1){
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("}")!=-1){
                            contador--;
                            cadenaEntonces+=cadena;
                        }else{
                            cadenaEntonces+=cadena;
                        }
                    }
                    System.out.println(cadenaEntonces);
                    Accion a=new Accion(cadenaEntonces);
                    for(int i=0;i<a.acciones.size();i++){
                        acciones.add(a.acciones.get(i));
                    }


                }
            if(cadena.indexOf("PARA")!=-1){
                Vector accion=new Vector();
                accion.add(SALIR);
            }
            if(cadena.indexOf("MIENTRAS")!=-1){
                String num=new String("");
                Vector expresion=new Vector();
                if(cadena.indexOf("MIENTRAS")!=-1 && cadena.indexOf("{")!=-1){}
                else{cadena=st.nextToken();}
                StringTokenizer num_tok=new StringTokenizer(cadena," ");
                while(num_tok.hasMoreTokens()){
                    num=num_tok.nextToken();
                    if(num.equals("{") && num_tok.hasMoreTokens()){
                        System.out.println("entra");
                        expresion.add(MIENTRAS);
                        while(num_tok.hasMoreTokens()){
                            String num2=num_tok.nextToken().trim();
                            System.out.println(num2);
                            expresion.add(num2);
                        }
                    }else{
                        cadena=st.nextToken();
                        while(cadena.indexOf("{")!=-1 || cadena.trim().equals("\n"))
                            cadena=st.nextToken();
                        System.out.println("entra2");
                        cadena=st.nextToken();
                        System.out.println(cadena);
                        StringTokenizer num2_tok=new StringTokenizer(cadena);
                        expresion.add(MIENTRAS);
                        while(num2_tok.hasMoreTokens()){
                            String num2=num2_tok.nextToken().trim();
                            System.out.println(num2);
                            expresion.add(num2);
                        }
                    }

                }
                System.out.println(cadena);
                cadena=st.nextToken();
                System.out.println(cadena);
                while(cadena.indexOf("}")!=-1 || cadena.trim().isEmpty())
                    cadena=st.nextToken();
                if (cadena.indexOf("ENTONCES")!=-1){
                    System.out.println("Bloque ENTONCES");
                    cadena=st.nextToken();
                    String cadenaEntonces=new String("");
                    while(cadena.indexOf("{")==-1)
                        cadena=st.nextToken();
                    int contador=0;
                    while(contador!=-1){
                        cadena=st.nextToken();
                        if(cadena.indexOf("{")!=-1){
                            contador++;
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("{")!=-1 && cadena.indexOf("}")!=-1){
                            cadenaEntonces+=cadena;
                        }else if(cadena.indexOf("}")!=-1){
                            contador--;
                            cadenaEntonces+=cadena;
                        }else{
                            cadenaEntonces+=cadena;
                        }
                    }
                    System.out.println(cadenaEntonces);
                    Accion a=new Accion(cadenaEntonces);
                    expresion.add(a.acciones);

                }
                acciones.add(expresion);
            }
        }
    }
}
